#include <stdio.h>
#include <ctype.h>

/* dimensione nome del file */
#define DIM	80

/* lunghezza riga della tabella di dump */
#define STEP 10

/* carattere da stampare al posto di un byte non stampabile */
#define NOTPRINTABLE	'.'

/* riga di intestazione della tabella */
#define INTESTAZIONE	"Posizione             Bytes              Caratteri\n--------- ----------------------------- ----------\n"  

/* formato per la stampa delle posizioni */
#define SPECPOS	"%9d "

/* formato per la stampa del byte in esadecimale */
#define SPECBYTE	"%02X "

/* spazio vuoto nella tabella dei byte esadecimali */
#define SPACING	"   "

void intestazione(void)
{
	printf(INTESTAZIONE);
}

/* stampa la tabella di dump del file puntato da fr */
void dump(FILE *fr)
{
	int c, j, i = 0;

	/* memorizza la riga corrente di STEP caratteri */
	char stepstring[STEP+1];

	/* pone il carattere di terminazione in stepstring */
	stepstring[STEP] = 0;

	while((c = fgetc(fr)) !=  EOF) {

		/* se siamo alla fine di una riga */
		if(!(i % STEP)) {

			/* se questa non e' la prima riga */
			if(i) 
				/* stampa la riga dei caratteri e poi va a capo */
				printf("%s\n",stepstring);
			
			/* stampa la posizione */
			printf(SPECPOS,i);
		}

		/* stampa il byte corrente in esadecimale */
		printf(SPECBYTE,c);

		/* pone in stepstring il carattere corrente o NOTPRINTABLE se il byte non e' stampabile */
		stepstring[i++ % STEP] = isprint(c) ? c : NOTPRINTABLE;
	}

	/* rimane da gestire l'ultima riga */

	/* se l'ultima riga e' incompleta calcolo quanti spazi stampare per completarla */
	if((j = i % STEP)) {

		/* termino stepstring al punto giusto */
		stepstring[j] = 0;
		/* stampo spazi per i byte mancanti */
		for(;j < STEP; j++)
			printf(SPACING);
	}
	
	/* stampo stepstring */
	printf("%s\n",stepstring);
}

int main(void)
{
	FILE *fr;
	char nomefile[DIM];

	printf("Immetti nome del file:\n");
	scanf("%s",nomefile);

	/* apre il file in modalita lettura formato binario */
	if(!(fr = fopen(nomefile,"rb"))) {
		fprintf(stderr,"Impossibile aprire il file %s.\n",nomefile);
		return -1;
	}

	intestazione();

	dump(fr);

	fclose(fr);
	return 0;
}
