#include <stdio.h>
#include <ctype.h>
#include <string.h>

#define SIZEWORD	80	

/* Per svuotare il buffer di input dai caratteri non ancora letti. */
/* Permette di ripartire con una nuova linea di input "pulita" */
#define svuotainput()	while(getchar() != '\n')

/* messaggio di errore */
#define ERR_MSG "Input non corretto. Ripetere prego.\n"

void errore_input(void)
{
	printf(ERR_MSG);
}

char leggi_si_no(char *msg)
{
	int c;

	/* cicla fino a quando l'utente immette 's' o 'n' */
	while(1) {
		printf("%s (s/n)\n",msg);
		/* restituisce 1 se il carattere letto e' 's' e il successivo e' newline */
		/* restituisce 0 se il carattere letto e' 'n' e il successivo e' newline */
		/* altrimenti procede nel ciclo */ 
		if(((c = getchar()) == 's' || c == 'n') && getchar() == '\n') {
			return c == 's';
		}
		errore_input();
		svuotainput();
	}
}

void saltaspazi(void)
{
	int c;

	/* cicla fino a leggere un carattere non di spaziatura */
	while(isspace(c = getchar()))
		;
	/* rimette l'ultimo carattere letto (che non e' di spaziatura), nel buffer di input */
	ungetc(c,stdin);
}

char leggispazio(void)
{
	/* usiamo !! in modo che restituisca 1 sse il carattere letto e' di spaziatura */
      /* (ricordo che isspace restituisce un valore non precisato >0 sse il carattere letto e' di spaziatura) */
	return !!isspace(getchar());
}

int legginumero_nonnegativo(void)
{
	int c = getchar();
	int n = 0;
	
	/* se il carattere letto non e' una cifra restituisce -1 */
	if(isdigit(c))
		n = c - '0';
	else
		return -1;
	/* cicla fino a leggere un carattere che non e' una cifra */
	while(isdigit(c = getchar())) {
		/* costruisce il valore intero moltiplicando il risultati parziale per 10 */
		/* e sommando il valore della cifra appena letta */
		n *= 10;
		n += c - '0';
	}
	/* rimette nel buffer di input l'ultimo carattere letto (dato che non e' una cifra) */
	ungetc(c,stdin);
	return n;
}

char leggiparola(char *word)
{
	int i = 0;

	/* se il carattere letto non e' alfanumerico ritorna 0 */
	if(!isalnum(word[i++] = getchar()))
		return 0;
	/* cicla fino a leggere un carattere non alfanumerico e assegna i caratteri */
      /* letti a posizioni successive dell'array word */
	while(isalnum(word[i++] = getchar()))
		;
	/* rimette nel buffer di input l'ultimo carattere letto (dato che non e' alfanumerico) */
      /* decrementa i in modo che i sia la posizione successiva all'ultimo carattere da memorizzare */
	ungetc(word[--i],stdin);
	/* pone in questa posizione il carattere di terminazione della stringa */
	word[i] = 0;
	return 1;
}

/* main di test, vedi il testo dell'esercizio */
int main(void)
{
	int x;
	char w[SIZEWORD + 1];

	if(!leggi_si_no("Procediamo ?"))
		return -1;
	saltaspazi();
	x = legginumero_nonnegativo();
	if(!leggispazio()) {
		printf("x = %d.\n",x);
		return 0;
	}
	saltaspazi();
	if(leggiparola(w))
		printf("x = %d, w = %s.\n",x,w);
	else
		printf("x = %d.\n",x);
	return 0;
}
